variables:
  DOCKER_DRIVER: overlay2
  DOCKER_IMAGE: docker:latest
  BUILDX_VERSION: v0.6.3
  NWJS_RELEASE: 0.60.0-1

services:
    - docker:dind

stages:
  - build
  - deploy

default:
  image: ${DOCKER_IMAGE}
  interruptible: true

amd64-deb:
  stage: build
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
  artifacts:
    paths:
      - artifacts
  before_script:
    - mkdir -p artifacts
    - |
      echo -e "\e[0Ksection_start:`date +%s`:install_buildx[collapsed=true]\r\e[0KInstalling BuildX"
      mkdir -p ~/.docker/cli-plugins
      wget -O ~/.docker/cli-plugins/docker-buildx https://github.com/docker/buildx/releases/download/$BUILDX_VERSION/buildx-$BUILDX_VERSION.linux-amd64
      chmod +x ~/.docker/cli-plugins/docker-buildx
      docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
      echo -e "\e[0Ksection_end:`date +%s`:install_buildx\r\e[0K"
  script:
    - |
      echo "Staring Script"
      echo -e "\e[0Ksection_start:`date +%s`:docker_buildx[collapsed=true]\r\e[0KBuilding Docker BuildX"
      docker buildx create --platform linux/amd64
      docker buildx build --platform linux/amd64 --tag amd64 . --load
      echo -e "\e[0Ksection_end:`date +%s`:docker_buildx\r\e[0K"
      docker run -v `pwd`:/build -w /build amd64 
      ls -lar artifacts

i386-deb:
  stage: build
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
  artifacts:
    paths:
      - artifacts
  before_script:
    - mkdir -p artifacts
    - |
      echo -e "\e[0Ksection_start:`date +%s`:install_buildx[collapsed=true]\r\e[0KInstalling BuildX"
      mkdir -p ~/.docker/cli-plugins
      wget -O ~/.docker/cli-plugins/docker-buildx https://github.com/docker/buildx/releases/download/$BUILDX_VERSION/buildx-$BUILDX_VERSION.linux-amd64
      chmod +x ~/.docker/cli-plugins/docker-buildx
      docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
      echo -e "\e[0Ksection_end:`date +%s`:install_buildx\r\e[0K"
  script:
    - |
      echo "Staring Script"
      echo -e "\e[0Ksection_start:`date +%s`:docker_buildx[collapsed=true]\r\e[0KBuilding Docker BuildX"
      docker buildx create --platform linux/386
      docker buildx build --platform linux/386 --tag i386 . --load
      echo -e "\e[0Ksection_end:`date +%s`:docker_buildx\r\e[0K"
      docker run -v `pwd`:/build -w /build i386
      ls -lar artifacts

armhf-deb:
  stage: build
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
  artifacts:
    paths:
      - artifacts
  before_script:
    - mkdir -p artifacts
    - |
      echo -e "\e[0Ksection_start:`date +%s`:install_buildx[collapsed=true]\r\e[0KInstalling BuildX"
      mkdir -p ~/.docker/cli-plugins
      wget -O ~/.docker/cli-plugins/docker-buildx https://github.com/docker/buildx/releases/download/$BUILDX_VERSION/buildx-$BUILDX_VERSION.linux-amd64
      chmod +x ~/.docker/cli-plugins/docker-buildx
      docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
      echo -e "\e[0Ksection_end:`date +%s`:install_buildx\r\e[0K"
  script:
    - |
      echo "Staring Script"
      echo -e "\e[0Ksection_start:`date +%s`:docker_buildx[collapsed=true]\r\e[0KBuilding Docker BuildX"
      docker buildx create --platform linux/arm/v7
      docker buildx build --platform linux/arm/v7 --tag armhf . --load
      echo -e "\e[0Ksection_end:`date +%s`:docker_buildx\r\e[0K"
      docker run -v `pwd`:/build -w /build armhf
      ls -lar artifacts

arm64-deb:
  stage: build
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
  artifacts:
    paths:
      - artifacts
  before_script:
    - mkdir -p artifacts
    - |
      echo -e "\e[0Ksection_start:`date +%s`:install_buildx[collapsed=true]\r\e[0KInstalling BuildX"
      mkdir -p ~/.docker/cli-plugins
      wget -O ~/.docker/cli-plugins/docker-buildx https://github.com/docker/buildx/releases/download/$BUILDX_VERSION/buildx-$BUILDX_VERSION.linux-amd64
      chmod +x ~/.docker/cli-plugins/docker-buildx
      docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
      echo -e "\e[0Ksection_end:`date +%s`:install_buildx\r\e[0K"
  script:
    - |
      echo "Staring Script"
      echo -e "\e[0Ksection_start:`date +%s`:docker_buildx[collapsed=true]\r\e[0KBuilding Docker BuildX"
      docker buildx create --platform linux/arm64/v8
      docker buildx build --platform linux/arm64/v8 --tag arm64 . --load
      echo -e "\e[0Ksection_end:`date +%s`:docker_buildx\r\e[0K"
      docker run -v `pwd`:/build -w /build arm64
      ls -lar artifacts

# copy release assets to NR0Q's server
uploadrelease:
  stage: deploy
  image: alpine
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
  before_script:
    - |
      apk add openssh-client
      eval $(ssh-agent -s)
      echo "$NR0Q_SERVER_KEY" | tr -d '\r' | ssh-add -
      mkdir -p ~/.ssh; chmod 700 ~/.ssh
  script:
    - |
      cd artifacts
      for FILE in *.*
      do
        echo "Calculating MD5 Hash for $FILE"
        md5sum $FILE > $FILE.md5
      done
      ssh -o StrictHostKeyChecking=no -p $NR0Q_SSH_PORT gridtracker@$NR0Q_SERVER_ADDRESS "mkdir -p ~/nwjs/${NWJS_RELEASE}" && scp -o StrictHostKeyChecking=no -P $NR0Q_SSH_PORT -r ./* gridtracker@$NR0Q_SERVER_ADDRESS:~/nwjs/${NWJS_RELEASE}/
